/*====================================================================================
   This file is part of the TechTools Plugin Development Kit. 
   Copyright (c) 2011 by TechTools  

   You may modify this file and/or create derived works to develop plugins 
   for use with TechTools's DigiView software and capture files obtained from
   TechTools' hardware. Any other use is prohibited.

            email: support@tech-tools.com,  sales@tech-tools.com 
		web: www.tech-tools.com   Voice:972-272-9392  FAX: 972-494-5814
======================================================================================*/

#pragma once

#include <SDKDDKVer.h>
#include <stdio.h>
#include <tchar.h>
#include <io.h>        // for _setmode
#include <fcntl.h>     // for _O_BINARY constant
#include <string>
#include <vector>      // for string list container

using namespace std;

typedef _int64 int64;
typedef unsigned _int64 uint64;

//enum FIELDTYPES {STARTFRAME, STARTFIELD, ENDFRAME, ENDFIELD, CNTLHALT, CNTLNOSAVE, CNTLSAVE};
enum CNTLCODES {CNTLHALT, CNTLNOSAVE, CNTLSAVE, CNTLUNKNOWN};  // note: CNTLUNKNOWN is a sentinal

// We use an 8 byte packet for all app<->plug-in communications. Define a 
// union to allow easy access to data as Int64, hi/low int32s or as array of 8 bytes.
union Data64
{
	unsigned _int8 bytes[8];
	struct {_int32 lowint; _int32 highint; };
	_int64  i64;  
};


// public routines from the command parser (OUR CODE)
void StartFrame(int64 timestamp, Data64 data, unsigned char FormatID);
void StartField(int64 timestamp, Data64 data, unsigned char FormatID);
void EndFrame(int64 timestamp);
void EndField(int64 timestamp);
void SendControl(int64 timestamp,unsigned char CntlCode);

void FindChannelLimits(uint64 mask, uint64 &HighestBit,uint64 &LowestBit);
unsigned _int64 pack(uint64 dat, uint64 mask,uint64 HighBit, uint64 LowBit);

// public routines in the post-parser (YOUR CODE)
void OnLoad();
void GetStrList(int ID, vector<string> &strl);
void SetInitItem(unsigned char ID, unsigned char subID, int value);
void SetCfgItem(unsigned char ID, unsigned char subID, int value);
void StartOfData();
void Parse(int64 timestamp, Data64 rawdata);
void EndOfData();
void OnUnLoad();
